

/**
 * @brief This structure contains the scan result
 *
 */
typedef struct {
    WCHAR wcsDecodeValue [MAX_PATH]; 
    WCHAR wcsSymName [MAX_PATH];
    WCHAR wcsSymId;
    DWORD dwSymType;
    DWORD dwDecodeLength;
    WCHAR wcsDecodeValueEx [MAX_PATH * 15]; 
    DWORD dwDecodeTimeMillisecond;
} DECODE_RESULT, *P_DECODE_RESULT;

#ifdef HHDECODEAPI_EXPORTS
#define DLLEXPORT __declspec(dllexport)
#else
#define DLLEXPORT __declspec(dllimport)
#endif

#define DCD_MODULE_TYPE_NX8CAP2D	1

#define DCD_RESULT_USERMSG			0
#define DCD_RESULT_KBDMSG			1
#define DCD_RESULT_COPYPASTE		2

#define WM_DECODE_DONE              (WM_USER+0x7777)

#define DCD_SYM_UPCA					0
#define DCD_SYM_UPCE					1
#define DCD_SYM_UPCE1					2
#define DCD_SYM_EAN8					3
#define DCD_SYM_EAN13					4
#define DCD_SYM_CODE39					5
#define DCD_SYM_CODE32					6
#define DCD_SYM_CODABAR					7
#define DCD_SYM_CODE128					8
#define DCD_SYM_ISBT128					9
#define DCD_SYM_ISBT128CONCATENATED		10
#define DCD_SYM_CODE93					11
#define DCD_SYM_INTERLEAVED_2OF5		12
#define DCD_SYM_DISCRETE_2OF5			13
#define DCD_SYM_DISCRETE_2OF5IATA		14
#define DCD_SYM_CODE11					15
#define DCD_SYM_MSI						16
#define DCD_SYM_GS1_128					17
#define DCD_SYM_BOOKLAND_EAN			18
#define DCD_SYM_TRIOPTIC_CODE39			19
#define DCD_SYM_COUPON_CODE				20
#define DCD_SYM_GS1_DATABAR				21
#define DCD_SYM_GS1_DATABAR_LIMITED		22
#define DCD_SYM_GS1_DATABAR_EXPANDED	23
#define DCD_SYM_MATRIX_2OF5				24
#define DCD_SYM_UCC_COMPOSITE			25
#define DCD_SYM_TLC39					26
#define DCD_SYM_CHINESE_2OF5			27
#define DCD_SYM_KOREAN_3OF5				28
#define DCD_SYM_ISSN_EAN				29
#define DCD_SYM_PDF417					30
#define DCD_SYM_MACRO_PDF417			31
#define DCD_SYM_MICRO_PDF417			32
#define DCD_SYM_AZTEC					33
#define DCD_SYM_AZTEC_RUNE				34
#define DCD_SYM_DATAMATRIX				35
#define DCD_SYM_QR_CODE					36
#define DCD_SYM_MICROQR					37
#define DCD_SYM_MAXICODE				38
#define DCD_SYM_US_POSTNET				39
#define DCD_SYM_US_PLANET				40
#define DCD_SYM_JAPAN_POSTAL			41
#define DCD_SYM_UK_POSTAL				42
#define DCD_SYM_NETHERLANDSKIXCODE		43
#define DCD_SYM_AUSTRALIA_POST			44
#define DCD_SYM_USPS_4CB				45
#define DCD_SYM_UPU_FICS_POSTAL			46

const DWORD Se475xSymList[] = {
	DCD_SYM_UPCA,
	DCD_SYM_UPCE,
	DCD_SYM_UPCE1,
	DCD_SYM_EAN8,
	DCD_SYM_EAN13,
	DCD_SYM_CODE39,
	DCD_SYM_CODE32,
	DCD_SYM_CODABAR,
	DCD_SYM_CODE128,
	DCD_SYM_ISBT128,
	DCD_SYM_ISBT128CONCATENATED,
	DCD_SYM_CODE93,
	DCD_SYM_INTERLEAVED_2OF5,
	DCD_SYM_DISCRETE_2OF5,
	DCD_SYM_DISCRETE_2OF5IATA,
	DCD_SYM_CODE11,
	DCD_SYM_MSI,
	DCD_SYM_GS1_128,
	DCD_SYM_BOOKLAND_EAN,
	DCD_SYM_TRIOPTIC_CODE39,
	DCD_SYM_COUPON_CODE,
	DCD_SYM_GS1_DATABAR,
	DCD_SYM_GS1_DATABAR_LIMITED,
	DCD_SYM_GS1_DATABAR_EXPANDED,
	DCD_SYM_MATRIX_2OF5,
	DCD_SYM_UCC_COMPOSITE,
	DCD_SYM_TLC39,
	DCD_SYM_CHINESE_2OF5,
	DCD_SYM_KOREAN_3OF5,
	DCD_SYM_ISSN_EAN,
	DCD_SYM_PDF417,
	DCD_SYM_MACRO_PDF417,
	DCD_SYM_MICRO_PDF417,
	DCD_SYM_AZTEC,
	DCD_SYM_AZTEC_RUNE,
	DCD_SYM_DATAMATRIX,
	DCD_SYM_QR_CODE,
	DCD_SYM_MICROQR,
	DCD_SYM_MAXICODE,
	DCD_SYM_US_POSTNET,
	DCD_SYM_US_PLANET,
	DCD_SYM_JAPAN_POSTAL,
	DCD_SYM_UK_POSTAL,
	DCD_SYM_NETHERLANDSKIXCODE,
	DCD_SYM_AUSTRALIA_POST,
	DCD_SYM_USPS_4CB,
	DCD_SYM_UPU_FICS_POSTAL,
};

DLLEXPORT BOOL APIENTRY HH_Decode_Init(INT moduletype) ;
DLLEXPORT BOOL APIENTRY HH_Decode_DeInit() ;
DLLEXPORT BOOL APIENTRY HH_Decode_SetFactoryDefault() ;
DLLEXPORT BOOL APIENTRY HH_Decode_SetScanTimeout(DWORD dwScanTimeout) ;
DLLEXPORT BOOL APIENTRY HH_Decode_GetScanTimeout(DWORD * dwScanTimeout) ;
DLLEXPORT BOOL APIENTRY HH_Decode_SetEnable(BOOL enable) ;
DLLEXPORT BOOL APIENTRY HH_Decode_GetEnable(BOOL * enable) ;
DLLEXPORT BOOL APIENTRY HH_Decode_SetResultTarget(HWND hResultTarget) ;
DLLEXPORT BOOL APIENTRY HH_Decode_GetResultTarget(HWND * hResultTarget) ;
DLLEXPORT BOOL APIENTRY HH_Decode_SetResultType(DWORD dwResultType) ;
DLLEXPORT BOOL APIENTRY HH_Decode_GetResultType(DWORD * dwResultType) ;
DLLEXPORT BOOL APIENTRY HH_Decode_GetResult(DECODE_RESULT * pDecodeResult) ;
DLLEXPORT BOOL APIENTRY HH_Decode_SetPrefix(WCHAR * wcsPrefix) ;
DLLEXPORT BOOL APIENTRY HH_Decode_GetPrefix(WCHAR * wcsPrefix, DWORD * dwSize) ;
DLLEXPORT BOOL APIENTRY HH_Decode_SetSuffix(WCHAR * wcsSuffix) ;
DLLEXPORT BOOL APIENTRY HH_Decode_GetSuffix(WCHAR * wcsSuffix, DWORD * dwSize) ;
DLLEXPORT BOOL APIENTRY HH_Decode_SetBeepEnable(BOOL enable) ;
DLLEXPORT BOOL APIENTRY HH_Decode_GetBeepEnable(BOOL * enable) ;
DLLEXPORT BOOL APIENTRY HH_Decode_SetBeepSuccessFile(WCHAR * wcsBeepSuccessFile) ;
DLLEXPORT BOOL APIENTRY HH_Decode_GetBeepSuccessFile(WCHAR * wcsBeepSuccessFile, DWORD * dwSize) ;
DLLEXPORT BOOL APIENTRY HH_Decode_SetBeepFailFile(WCHAR * wcsBeepFailFile) ;
DLLEXPORT BOOL APIENTRY HH_Decode_GetBeepFailFile(WCHAR * wcsBeepFailFile, DWORD * dwSize) ;
DLLEXPORT BOOL APIENTRY HH_Decode_SymSetEnable(DWORD symIndex, BOOL enable) ; 
DLLEXPORT BOOL APIENTRY HH_Decode_SymGetEnable(DWORD symIndex, BOOL * enable) ; 
DLLEXPORT BOOL APIENTRY HH_Decode_SymGetName(DWORD symIndex, WCHAR * pName) ; 
DLLEXPORT BOOL APIENTRY HH_Decode_Trigger(BOOL start) ;


