// ScannerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Scanner.h"
#include "ScannerDlg.h"
#include "HHDecodeApi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CScannerDlg dialog
BOOL b_Init = FALSE;

CScannerDlg::CScannerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScannerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CScannerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, m_CtrlBarcode);
}

BEGIN_MESSAGE_MAP(CScannerDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
//	ON_BN_CLICKED(IDC_BUTTON1, &CScannerDlg::OnBnClickedButton1)
//	ON_BN_CLICKED(IDC_BUTTON2, &CScannerDlg::OnBnClickedButton2)
//	ON_BN_CLICKED(IDC_BUTTON3, &CScannerDlg::OnBnClickedButton3)
//	ON_BN_CLICKED(IDC_BUTTON4, &CScannerDlg::OnBnClickedButton4)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_INIT, &CScannerDlg::OnBnClickedButtonInit)
	ON_BN_CLICKED(IDC_BUTTON_DEINIT, &CScannerDlg::OnBnClickedButtonDeinit)
	ON_BN_CLICKED(IDC_BUTTON_FACTORYDEFAULT, &CScannerDlg::OnBnClickedButtonFactorydefault)
	ON_BN_CLICKED(IDC_BUTTON_SCANTIMEOUT, &CScannerDlg::OnBnClickedButtonScantimeout)
	ON_BN_CLICKED(IDC_BUTTON_RESULTTARGET, &CScannerDlg::OnBnClickedButtonResulttarget)
	ON_BN_CLICKED(IDC_BUTTON_SCAN, &CScannerDlg::OnBnClickedButtonScan)
END_MESSAGE_MAP()


// CScannerDlg message handlers

BOOL CScannerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CScannerDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SCANNER_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SCANNER_DIALOG));
	}
}
#endif


void CScannerDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
}

void CScannerDlg::OnBnClickedButtonInit()
{
	// TODO: Add extra initialization here
	b_Init = HH_Decode_Init(DCD_MODULE_TYPE_NX8CAP2D);

	if( !b_Init )
		MessageBox( L"HH_Decode_Init FAILED !", L"Scanner", MB_OK );
		
	HH_Decode_SetResultType(DCD_RESULT_KBDMSG);
	
	HH_Decode_SetPrefix(L"");
	HH_Decode_SetSuffix(L"");
	
	//HH_Decode_SetBeepSuccessFile(L"\\Programme\\Scanner\\PlausiWeich.wav");
	//HH_Decode_SetBeepFailFile(L"\\Programme\\Scanner\\PlausiHart.wav");
}

void CScannerDlg::OnBnClickedButtonDeinit()
{
	HH_Decode_DeInit();
}

void CScannerDlg::OnBnClickedButtonFactorydefault()
{
	if( !HH_Decode_SetFactoryDefault())
		MessageBox( L"HH_Decode_SetFactoryDefault FAILED !", L"Scanner", MB_OK );
}

void CScannerDlg::OnBnClickedButtonScantimeout()
{
	if( ! HH_Decode_SetScanTimeout(3000) )
		MessageBox( L"HH_Decode_SetScanTimeout FAILED !", L"Scanner", MB_OK );
}

void CScannerDlg::OnBnClickedButtonResulttarget()
{
	if( ! HH_Decode_SetResultTarget(m_hWnd) )
		MessageBox( L"HH_Decode_SetResultTarget FAILED !", L"Scanner", MB_OK );
	else
		HH_Decode_SetResultType(DCD_RESULT_USERMSG);
}

LRESULT CScannerDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	if( message == WM_DECODE_DONE )
	{
		DECODE_RESULT DecodeResult;
		//WCHAR Name[64];
		HH_Decode_GetResult(&DecodeResult);
		m_CtrlBarcode.SetWindowTextW(DecodeResult.wcsDecodeValue);
		return 0;
	}
	
	return CDialog::DefWindowProc(message, wParam, lParam);
}

LRESULT CScannerDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	//Works also:

	/*
	if( message == WM_DECODE_DONE )
	{
		DECODE_RESULT DecodeResult;
		//WCHAR Name[64];
		HH_Decode_GetResult(&DecodeResult);
		m_CtrlBarcode.SetWindowTextW(DecodeResult.wcsDecodeValue);
		return 0;
	}
	*/
	return CDialog::WindowProc(message, wParam, lParam);
}

void CScannerDlg::OnBnClickedButtonScan()
{
	DWORD res = 0;
	
	m_CtrlBarcode.SetWindowTextW( L"");
	
	HH_Decode_GetResultType(&res);

	if( res == DCD_RESULT_KBDMSG )
		m_CtrlBarcode.SetFocus();

	HH_Decode_Trigger(TRUE);
}
