﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Microsoft.WindowsCE.Forms;
using HHDecodeApi.Net;

namespace ScannerCS
{
    public partial class Form1 : Form
    {
        MsgHandler m_MsgHandler;

        public Form1()
        {
            InitializeComponent();

            m_MsgHandler = new MsgHandler(this);

            if( !CHHDecodeApi.HH_Decode_Init((int)CHHDecodeApi.MODULE_TYPE.DCD_MODULE_TYPE_NX8CAP2D) )
            {
                MessageBox.Show( "Init failed!");
                return;
            }
            
            CHHDecodeApi.HH_Decode_SetPrefix("");
            CHHDecodeApi.HH_Decode_SetSuffix("");

        }

        private void button2_Click(object sender, EventArgs e)
        {
            CHHDecodeApi.HH_Decode_SetResultType((int)CHHDecodeApi.RESULT_TYPE.DCD_RESULT_KBDMSG);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            CHHDecodeApi.HH_Decode_SetResultType((int)CHHDecodeApi.RESULT_TYPE.DCD_RESULT_USERMSG);
            CHHDecodeApi.HH_Decode_SetResultTarget(m_MsgHandler.Hwnd);
        }
        
        private void btScan_Click(object sender, EventArgs e)
        {
            tbResult.Focus();
            
            CHHDecodeApi.HH_Decode_Trigger(true);
        }

        private void btClose_Click(object sender, EventArgs e)
        {
            CHHDecodeApi.HH_Decode_DeInit();

            this.Close();
        }

        public void ShowResult()
        {
            CHHDecodeApi.DECODE_RESULT res = new CHHDecodeApi.DECODE_RESULT();

            unsafe
            {
                int iSize = Marshal.SizeOf(typeof(CHHDecodeApi.DECODE_RESULT));
                IntPtr ipOut = Marshal.AllocCoTaskMem(iSize);

                try
                {
                    if (CHHDecodeApi.HH_Decode_GetResult(ipOut))  //(&res)
                    {
                        res = (CHHDecodeApi.DECODE_RESULT)Marshal.PtrToStructure(ipOut, typeof(CHHDecodeApi.DECODE_RESULT));

                        MessageBox.Show("DECODE result: " + res.tcDecodeValue);
                    }
                    else
                        MessageBox.Show("DECODE result fail");
                }
                finally
                {
                    Marshal.FreeCoTaskMem(ipOut);
                    ipOut = IntPtr.Zero;
                }
            }
        }

        public class MsgHandler : MessageWindow
        {
            public const int WM_USER = 0x0400;
            public const int WM_DECODE_DONE = WM_USER + 0x7777;

            private Form1 m_myForm;

            public MsgHandler(Form1 form)
            {
                m_myForm = form;
            }
            // It is receive window message and get barcode data
            protected override void WndProc(ref Message msg)
            {
                switch (msg.Msg)
                {
                    case WM_DECODE_DONE:
                        m_myForm.ShowResult();
                        break;
                }

                base.WndProc(ref msg);
            }
        }

        
    }
}